Introduce the notion of weekly and monthly snapshots.
[wizbackup.git] / wizbackup
1 #!/bin/bash
2 #
3 # WizBackup 2.0 - Simple rsync backup with snapshots
4 # Based on incremental-backup 0.1 by Matteo Mattei
5 #
6 # Copyright 2006 Matteo Mattei <matteo.mattei@gmail.com>
7 # Copyright 2007, 2008, 2009, 2010, 2011, 2015 Bernie Innocenti <bernie@codewiz.org>
8 #
9 #  This program is free software: you can redistribute it and/or modify
10 #  it under the terms of the GNU General Public License as published by
11 #  the Free Software Foundation, either version 3 of the License,
12 #  or (at your option) any later version.
13 #
14 #  This program is distributed in the hope that it will be useful,
15 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
16 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 #  GNU General Public License for more details.
18 #
19 #  You should have received a copy of the GNU General Public License
20 #  along with this program.  If not, see <http://www.gnu.org/licenses/>.
21 #
22
23 if [ $# -lt 2 ]; then
24         echo "Usage: $0 SOURCE DEST [RSYNC_OPTS]"
25         exit 1
26 fi
27
28 # Treat undefined variables as errors
29 set -u
30
31 #####################################################################
32 # CONFIGURATION
33 #####################################################################
34
35 # Source rsync URL
36 SRC=$1; shift
37
38 # Destination directory (will be created if it doesn't exist)
39 DEST=$1; shift
40
41 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
42 # NOTE: --inplace will clobber linked files in older snapshots. DON'T USE IT!
43 RSYNC_OPTS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-excluded --ignore-errors $@"
44
45 # Number of months to keep
46 MONTHS=3
47
48 # Abort backup if the destination volume has less than these GBs free
49 MIN_FREE_GB=10
50
51 RESULT=500
52 DATE=$(date +"%Y%m%d")
53 if [ $(date +"%d") = 1 ]; then
54         DATE="$DATE-monthly"
55 elif [ $(date +"%w") = 0 ]; then
56         DATE="$DATE-weekly"
57 fi
58 DEST="`echo $DEST | sed -e 's/\/$//'`"
59
60
61 # Use "backup" ssh key with ssh protocol, or password file for rsync protocol
62 if [ "${SRC%:*}" == "rsync" ]; then
63         RSYNC_OPTS="$RSYNC_OPTS --password-file=/etc/wizbackup/rsync_password --contimeout 10"
64 else
65         export RSYNC_RSH="ssh -i /etc/wizbackup/ssh_id -c arcfour -x -o VerifyHostKeyDNS=yes -o StrictHostKeyChecking=no"
66 fi
67
68 # Error tolerant grep
69 tgrep() {
70         grep "$@"
71         return 0
72 }
73
74 do_backup() {
75         set -o pipefail
76         echo "$(date): rsync $RSYNC_OPTS $SRC $DEST/tmp/"
77         rsync $RSYNC_OPTS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
78         RESULT=$?
79         case "$RESULT" in
80         0|24)
81                 RESULT=0 # Ignore error 24 (Partial transfer due to vanished source files)
82                 # Cleanup old incomplete backups
83                 if [ -d "$DEST/$DATE" ]; then
84                         echo "$(date): Removing existing backup $DEST/$DATE"
85                         rm -rf "$DEST/$DATE"
86                 fi
87                 mv "$DEST/tmp" "$DEST/$DATE"
88                 ;;
89         *)
90                 echo "$(date): rsync failed: $RESULT"
91                 echo "$(date): Leaving incomplete backup in $DEST/tmp"
92                 ;;
93         esac
94         set +o pipefail
95 }
96
97 do_init() {
98         # Safety net (4 slashes just in case)
99         case "$DEST" in
100                 /|//|///|////) exit 666 ;;
101         esac
102
103         if [ ! -d "$DEST" ]; then
104                 echo "$(date): Creating missing destination directory $DEST."
105                 mkdir -p "$DEST" || exit 667
106         fi
107
108         cd "$DEST" || exit 668
109 }
110
111 do_prune() {
112         local num_snapshots="$1"
113         local suffix="$2"
114         local oldest="$(ls -d [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$suffix | head -n -$num_snapshots)"
115         for old in $oldest; do
116                 echo "$(date): Removing oldest snapshot(s): $old..."
117                 rm -rf "$old" || exit 669
118         done
119 }
120
121 do_link() {
122         local newest=`ls -d [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]* | tail -n 1`
123         if [ -d "$DEST/tmp" ]; then
124                 echo "$(date): Continuing with pre-existing snapshot $DEST/tmp"
125         elif [ -z "$newest" ]; then
126                 echo "$(date): No previous snapshot found, performing a full backup!"
127         else
128                 echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
129                 # TODO: Creating the hardlinks takes a lot of time.
130                 # Perhaps we could save time by recycling the oldest snapshot
131                 cp -la "$DEST/$newest" "$DEST/tmp"
132                 RESULT=$?
133                 if [ $RESULT -ne 0 ]; then
134                         echo "$(date): Failed to setup tmp snapshot: $RESULT. Cleaning up."
135                         rm -rf "$DEST/tmp"
136                         exit $RESULT
137                 fi
138         fi
139 }
140
141 do_test() {
142         # TODO: test for free space and free inodes in the $DEST filesystem
143         block_size=`stat --file-system --format "%S" "$DEST"`
144         free_blocks=`stat --file-system --format "%f" "$DEST"`
145         free_inodes=`stat --file-system --format "%d" "$DEST"`
146         free_gb=$((block_size * free_blocks / 1024 / 1024 / 1024))
147
148         if [ "$free_gb" -lt "$MIN_FREE_GB" ]; then
149                 echo "$(date): Aborting due to insufficient free space ${free_gb}GB."
150                 exit 670
151         fi
152
153         # Avoid clobbering the latest snapshot if the remote host does
154         # not allow us to connect
155         # --contimeout: sometimes hangs on connection...
156         rsync $RSYNC_OPTS --dry-run --no-recursive "$SRC" >/dev/null
157         RESULT=$?
158         if [ $RESULT -ne 0 ]; then
159                 echo "$(date): rsync test failed: $RESULT.  Aborting."
160                 exit $RESULT
161         fi
162 }
163
164 ######################################
165 # Main
166 ######################################
167
168 # make sure to be root
169 if (( `id -u` != 0 )); then { echo "Sorry, must be root.  Exiting..."; exit; } fi
170
171 echo "$(date): BEGIN backup: $SRC -> $DEST"
172 echo "$(date): $0 $SRC $DEST $@"
173 do_init
174 do_prune 6 ""
175 do_prune 4 "-weekly"
176 do_prune $MONTHS "-monthly"
177 do_test
178 do_link
179 do_backup
180 echo "$(date): END backup: $SRC -> $DEST"
181
182 exit $RESULT